
//Edge
class Edge { 


  // position
  PVector anchor;

  // Rest length and spring constant
  float len, d, y, stretch;
  float k = springConstant+(random(1)/200.0);
  int id; 

  Node a;
  Node b;




  // Constructor
  Edge(Node a_, Node b_, float l) {

    a = a_;
    b = b_;
    len = l;
  } 

  // Calculate spring force
  void update() {
    // Vector pointing from anchor to bob position
    PVector force = PVector.sub(a.position, b.position);
    // What is distance
    d = force.mag();
    // Stretch is difference between current distance and rest length
    stretch = d - len; 

    // Calculate force according to Hooke's Law
    // F = k * stretch
    force.normalize();
    force.mult(-1 * k * stretch);
    a.applyForce(force);
    force.mult(-1);
    b.applyForce(force);
  }


  void display() {
    //draw


    //line(a.position.x, a.position.y, b.position.x, b.position.y);
    //strokeWeight(3);
    //stroke(0, 255, 0, 128);
    //beginShape(LINES); 
    //vertex(a.position.x, a.position.y, a.position.z);
    //vertex(b.position.x, b.position.y, b.position.z);
    //endShape(); 

    //for (int i=a.hist.length-1; i>0; i--) {
    //  strokeWeight(3);
    float lerpFactor = map(stretch, 0, 10, 0.0, 1.0);
    lerpFactor = constrain(lerpFactor, 0, 1.0); 
    float alpha = 128; 
    color c = lerpColor(color(0, 0, 0, alpha), color(128, 128, 128, alpha), lerpFactor);
    strokeWeight(3);
    stroke(c);
    beginShape(LINES); 
    vertex(a.hist[0].x, a.hist[0].y, a.hist[0].z);
    vertex(b.hist[0].x, b.hist[0].y, b.hist[0].z);
    endShape();
    //}
  }

}
