class Node {
  PVector home;
  PVector position;
  PVector[] hist = new PVector[histLength];
  //int[] hist = new int[10];
  PVector velocity;
  PVector acceleration;
  float mass = 12;
  int id = 0;
  color col; 

  // Arbitrary damping to simulate friction / drag 
  float damping = damp;

  // For mouse interaction
  PVector dragOffset;

  // Constructor
  Node(int i, float x, float y, float z, color c) {
    home = new PVector(x, y, z);
    position = new PVector(x, y, z);
    velocity = new PVector();
    acceleration = new PVector();
    dragOffset = new PVector();
    id = i;
    col = c; 
    for (int p=0; p<histLength; p++) {
      hist[p] = new PVector(0, 0, 0);
    }
  } 

  // Standard Euler integration
  void update() { 

    //calc draw of home
    PVector homeForce = PVector.sub(position, home);
    float distToHome = homeForce.mag();
    homeForce.normalize();
    homeForce.mult(homeForceFactor * distToHome);
    applyForce(homeForce);

    velocity.add(acceleration);
    velocity.mult(damping);
    position.add(velocity);
    acceleration.mult(0);
  }

  void shiftAdd() {

    for (int index =hist.length-2; index >= 0; index-- ) {
      hist[index+1] = hist [index];
    }
    hist[0]=new PVector(position.x, position.y, position.z);
    //note must construct new PVector here, hist[0] = position makes all of hist the same. Why???
  }

  // Newton's law: F = M * A
  void applyForce(PVector force) {
    PVector f = force.get();
    f.div(mass);
    acceleration.add(f);
  }


  // Draw the node
  void display() { 

      noStroke(); 
      //color c = color(0, 255, 0, 255);
      //fill(c);

      //noStroke();
      //pushMatrix();
      //translate(position.x, position.y, position.z);
      //ellipseMode(CENTER); 
      ////println("from Nodeclass: "+hist[0]+" at "+0);
      //ellipse(0, 0, 15, 15);
      //popMatrix();

    //for (int i=hist.length-1; i>0; i--) {
    //  noStroke(); 
    //  //float lerpFactor = map(i, 0, hist.length-1, 0.0, 1.0);
    //  //color c = color(255, 255, 0, 128); //lerpColor(color(255, 255, 0, 255),color(0, 255, 0,255), lerpFactor); 
    //  float alpha = 255-(255.0/hist.length*i); 
    //  color thisCol = color(red(col), green(col), blue(col), alpha); 
    //  fill(thisCol);
      fill(col,255); 

      noStroke();
      pushMatrix();
      translate(position.x, position.y, position.z);
      //translate(hist[i].x, hist[i].y,hist[i].z);
      //println("from Nodeclass: "+hist[0]+" at "+0);
      sphere(sRad);
      popMatrix(); 
    //}
  } 

  // This checks to see if we hit the ring with the clapper
  void clicked(float mx, float my, float mz) {
    PVector mouseP = new PVector(mx, my, mz);
    position.dist(mouseP);//scale that
    PVector fr = PVector.sub(position, mouseP);
    //constrain
    float force = 1.0/fr.mag()*30000.0;
    fr.setMag(force);
    applyForce(fr); 
    //println("node: "+fr);
  }
}
